var d y eta u k n bw p mu Q varkappa i m xi gamma cbo c R z b g chi lf lambda sr nv w bdata;
varexo eeta evarkappa exi egamma ez eg echi er env;
parameters phi mus rho beta etas psi kappa xis delta vartheta sigma varpi Rs alpha by tao gy epsilon varsigma omega nvs rhoeta rhovarkappa rhoxi rhogamma rhoz rhog rhogz rhochi rhor nu1 nu2 nu3 rhonv;
varsigma=1;
alpha=0.36;
beta=0.9825;
delta=0.025;
Rs=1.01158;
tao=0.35;
by=3;
gy=0.179;
xis=0.1466;
mus=0.00616/xis;
vartheta=0.0383;

model (linear);
(1-alpha)/(1+mus)/etas*(bw+n-p)+delta*alpha/etas/vartheta*i+by/beta*(b(-1)-p)+(1+by/beta/Rs-(1-alpha)/(1+mus)/etas-delta*alpha/etas/vartheta-by/beta-alpha/etas/(1+phi))*d+alpha/etas*u=y+by/beta/Rs*(b-R-p);
(1-alpha)/(1+mus)/etas/((1-alpha)/(1+mus)/etas+delta*alpha/etas/vartheta)*(bw+n-p)+delta*alpha/etas/vartheta/((1-alpha)/(1+mus)/etas+delta*alpha/etas/vartheta)*i=xi+alpha/etas/vartheta/(alpha/etas/vartheta-by)*k-by/(alpha/etas/vartheta-by)*(b-p-Rs/(Rs-tao)*R);
k=(1-delta)*k(-1)+delta*(i+varkappa);
(1+phi)*u+k(-1)=n+bw-p+mus/(1+mus)*(mu+kappa*d);
(1-etas)*(rho*(p-p(-1))-beta*rho*(p(+1)-p))=y-eta-(1+phi)*u-k(-1);
(1+mus)*(Q+varkappa)-psi*(1+mus)*(i-i(-1))+beta*psi*(1+mus)*(i(+1)-i)+kappa*d=mus*mu;
(1+mus)*Q=(1+mus-mus*xis)*m+beta*(1-delta)*(1+mus)*Q(+1)+mus*xis*(mu+xi)+beta*vartheta*(phi*u(+1)-kappa*d(+1));
mus*xis*(mu+xi+kappa*d-tao/(Rs-tao)*R)+m+R=p(+1)-p+kappa*d(+1)-kappa*d;
(1-gy-delta*alpha/etas/vartheta-alpha/etas/(1+phi))*c+gy*g+by/beta/Rs*(b-p-R)=(1-alpha)/(1+mus)/etas*(bw+n-p)+by/beta*(b(-1)-p)+(1-delta*alpha/etas/vartheta-alpha/etas/(1+phi)+by/beta/Rs-(1-alpha)/(1+mus)/etas-by/beta)*d;
m+Rs/(Rs-tao)*R=p(+1)-p;
m=gamma(+1)-gamma-sigma*(cbo(+1)-cbo);
cbo=1/(1-varpi)*(c-varpi*c(-1));
w=(1-beta*omega)/(1-nvs/(1-nvs)/epsilon)*(p+nv+chi+lambda-nvs/(1-nvs)/epsilon*bw+1/epsilon*n)+beta*omega*w(+1);
bw=omega*bw(-1)+(1-omega)*w;
bw-p=chi+1/epsilon*lf+lambda;
lambda=(1-varsigma)*lambda(-1)+sigma*varsigma*cbo;
y=z+alpha*(k(-1)+u)+(1-alpha)*n;
sr=Rs/(Rs-tao)*R;
bdata=b-sr;
sr=rhor*sr(-1)+(1-rhor)*nu1*(p-p(-1))+(1-rhor)*(nu2+nu3)*y-(1-rhor)*nu3*y(-1)+er;
g=rhog*g(-1)+rhogz*(z-z(-1))+eg;
z=rhoz*z(-1)+ez;
xi=rhoxi*xi(-1)+exi;
nv=rhonv*nv(-1)+env;
eta=rhoeta*eta(-1)+eeta;
varkappa=rhovarkappa*varkappa(-1)+evarkappa;
chi=rhochi*chi(-1)+echi;
gamma=rhogamma*gamma(-1)+egamma;
end;


varobs y n i bw sr p c bdata lf;


estimated_params;
sigma, normal_pdf, 1.5, 0.37; 
epsilon, normal_pdf, 2, 0.75;
varpi, beta_pdf, 0.7, 0.1;
omega, beta_pdf, 0.5, 0.15;
rho, inv_gamma_pdf, 0.1, 0.3;
psi, inv_gamma_pdf, 0.1, 0.3;
phi, beta_pdf, 0.15, 0.15;
kappa, inv_gamma_pdf, 0.02, 0.01;
etas, beta_pdf, 1.2, 0.1, 0, 2;
nvs, beta_pdf, 1.2, 0.1, 0, 2;
rhoz, beta_pdf, 0.5, 0.2;
rhochi, beta_pdf, 0.5, 0.2;
rhoxi, beta_pdf, 0.5, 0.2;
rhonv, beta_pdf, 0.5, 0.2;
rhoeta, beta_pdf, 0.5, 0.2;
rhogamma, beta_pdf, 0.5, 0.2;
rhovarkappa, beta_pdf, 0.5, 0.2;
rhog, beta_pdf, 0.5, 0.2;
rhogz, beta_pdf, 0.5, 0.2;
stderr ez, inv_gamma_pdf, 0.001, 0.05;
stderr echi, inv_gamma_pdf, 0.001, 0.05;
stderr exi, inv_gamma_pdf,  0.001, 0.05;
stderr evarkappa, inv_gamma_pdf, 0.001, 0.05;
stderr env, inv_gamma_pdf,  0.001, 0.05;
stderr eeta, inv_gamma_pdf,  0.001, 0.05;
stderr egamma, inv_gamma_pdf, 0.001, 0.05;
stderr eg, inv_gamma_pdf, 0.001, 0.05;
stderr er, inv_gamma_pdf, 0.001, 0.05;
rhor, beta_pdf, 0.75, 0.1;
nu1, normal_pdf, 1.5, 0.25;
nu2, normal_pdf, 0.12, 0.05;
nu3, normal_pdf, 0.12, 0.05;
end;

estimation(datafile=laborinvest,first_obs=121,mode_compute=0,mode_file=code_mode,mh_replic=0,mh_jscale=0.5,mh_nblocks=2);

shock_decomposition(parameter_set=posterior_mode) y n;


